package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ContaMDDAO;
import com.rjconsultores.ventaboletos.entidad.ContaMD;
import com.rjconsultores.ventaboletos.service.ContaMDService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("contaMDService")
public class ContaMDServiceImpl implements ContaMDService {

	@Autowired
	private ContaMDDAO contaMDDAO;

	public List<ContaMD> obtenerTodos() {
		return contaMDDAO.obtenerTodos();
	}

	public ContaMD obtenerID(Integer id) {
		return contaMDDAO.obtenerID(id);
	}

	@Transactional
	public ContaMD suscribir(ContaMD entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return contaMDDAO.suscribir(entidad);
	}

	@Transactional
	public ContaMD actualizacion(ContaMD entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return contaMDDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(ContaMD entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		contaMDDAO.actualizacion(entidad);
	}

	@Override
	public Boolean existeConta(ContaMD conta) {
		return contaMDDAO.existeConta(conta);
	}

}
